<?php

/**
 * This file is used to install the plugin manually.
 *
 * Created: 2007-02-12
 * Last update: 2007-05-28
 *
 * @link http://deboutv.free.fr/mantis/
 * @author Vincent DEBOUT <deboutv@free.fr>
 * @package PluginManager
 * @version 0.1.0
 */

if ( !ereg( 'plugins_install_page.php', $_SERVER['PHP_SELF'] ) && !ereg( 'plugins_uninstall_page.php', $_SERVER['PHP_SELF'] ) ) {
    header( 'Location: ../../plugins_page.php' );
    exit();
}

$t_plugins_plugin_manager_step_count = array();
$t_plugins_plugin_manager_step_count['install'] = 4;
$t_plugins_plugin_manager_step_count['uninstall'] = 3;

function plugins_pluginmanager_install_description_plugin( $p_step ) {
    if ( $p_step == 1 ) {
        return 'SQL upgrade';
    } else if( $p_step == 2 ) {
        return 'Patching files';
    } else if ( $p_step == 3 ) {
        return 'Patching plugins';
    } else {
        return 'Finishing installation';
    }
}

function plugins_pluginmanager_uninstall_description_plugin( $p_step ) {
    if ( $p_step == 1 ) {
        return 'Moving installed files';
    } else if ( $p_step == 2 ) {
        return 'Remove menu link';
    } else {
        return 'Removing SQL tables';
    }
}

function plugins_pluginmanager_install_plugin( &$p_msg, $p_step ) {
    $p_msg = '';

    if ( $p_step == 1 ) {
        if ( db_is_connected() ) {
            $t_query = 'CREATE TABLE IF NOT EXISTS ' . config_get( 'db_table_prefix' ) . '_plugins_pm_list_table ( plugin varchar(50) NOT NULL, installed int(1) unsigned DEFAULT 0, PRIMARY KEY( plugin ) )';
            if ( !db_query( $t_query ) ) {
                return PLUGINS_PLUGINMANAGER_FAIL;
            }
            $t_query = 'CREATE TABLE IF NOT EXISTS ' . config_get( 'db_table_prefix' ) . '_plugins_pm_dependencies_table ( plugin varchar(50) NOT NULL, dependencies text, PRIMARY KEY( plugin ) )';
            if ( !db_query( $t_query ) ) {
                return PLUGINS_PLUGINMANAGER_FAIL;
            }
        } else {
            $p_msg = 'Database not connected';
            return PLUGINS_PLUGINMANAGER_FAIL;
        }
    } else if ( $p_step == 2 ) {
        if ( !is_writeable( 'core.php' ) || !pm_backup_file( 'core.php' ) ) {
            return PLUGINS_PLUGINMANAGER_FAIL;
        }
        if ( !isset( $g_plugins_manager_core ) ) {
            $t_file = fopen( 'core.php', 'a' );
            fwrite( $t_file, '<?php' . "\n\t" . 'if ( file_exists( \'plugins\' . DIRECTORY_SEPARATOR . \'pluginmanager\' . DIRECTORY_SEPARATOR . \'core.php\' ) ) {' );
            fwrite( $t_file, "\n\t\t" . 'require_once( \'plugins\' . DIRECTORY_SEPARATOR . \'pluginmanager\' . DIRECTORY_SEPARATOR . \'core.php\' );' );
            fwrite( $t_file, "\n\t\t" . '$g_plugins_manager_core = ON;' );
            fwrite( $t_file, "\n\t}\n" . '?>' );
            fclose( $t_file );
        }
        if ( file_exists( 'custom_strings_inc.php' ) && !pm_backup_file( 'custom_strings_inc.php' ) ) {
            return PLUGINS_PLUGINMANAGER_FAIL;
        }
        if ( !isset( $g_plugins_manager_lang ) ) {
            $t_file = fopen( 'custom_strings_inc.php', 'a' );
            fwrite( $t_file, '<?php' . "\n\t" . 'if ( file_exists( \'plugins\' . DIRECTORY_SEPARATOR . \'pluginmanager\' . DIRECTORY_SEPARATOR . \'lang_inc.php\' ) ) {' );
            fwrite( $t_file, "\n\t\t" . 'require_once( \'plugins\' . DIRECTORY_SEPARATOR . \'pluginmanager\' . DIRECTORY_SEPARATOR . \'lang_inc.php\' );' );
            fwrite( $t_file, "\n\t\t" . 'global $g_plugins_manager_lang;' . "\n\t\t" . '$g_plugins_manager_lang = ON;' );
            fwrite( $t_file, "\n\t}\n" . '?>' );
            fclose( $t_file );
        }
    } else if ( $p_step == 3 ) {
        $t_copy = true;
        $t_directory = 'plugins' . DIRECTORY_SEPARATOR . 'pluginmanager' . DIRECTORY_SEPARATOR . 'patch' . DIRECTORY_SEPARATOR;
        $t_dir = opendir( $t_directory );
        while( ( $t_file = readdir( $t_dir ) ) !== false ) {
            if ( preg_match( '/install_inc_([a-z]+).php/', $t_file, $t_match ) || preg_match( '/install_manual_inc_([a-z]+).php/', $t_file, $t_match ) ) {
                $t_copy = $t_copy & pm_file_copy( $t_directory . $t_file, 'plugins' . DIRECTORY_SEPARATOR . $t_match[1] . DIRECTORY_SEPARATOR . str_replace( '_' . $t_match[1], '', $t_file ) );
            }
        }
        closedir( $t_dir );
        if ( !$t_copy ) {
            $p_msg = 'Failed to patch the plugins';
            return PLUGINS_PLUGINMANAGER_WARNING;
        }
    } else {
        $t_main_menu_custom_options = config_get( 'main_menu_custom_options', array() );
        $t_main_menu_custom_options[] = array( 'plugins_pluginmanager_link', ADMINISTRATOR, 'plugins_page.php' );
        config_set( 'main_menu_custom_options', $t_main_menu_custom_options );
    }
    return PLUGINS_PLUGINMANAGER_OK;
}

function plugins_pluginmanager_upgrade_plugin( &$p_msg, $p_step ) {
    $p_msg = '';
    
    return PLUGINS_PLUGINMANAGER_OK;
}

function plugins_pluginmanager_install_undo_plugin( &$p_msg, $p_step ) {
    $p_msg = '';
    
    return PLUGINS_PLUGINMANAGER_OK;
}

function plugins_pluginmanager_upgrade_undo_plugin( &$p_msg, $p_step ) {
    $p_msg = '';
    
    return PLUGINS_PLUGINMANAGER_OK;
}

function plugins_pluginmanager_uninstall_undo_plugin( &$p_msg, $p_step ) {
    $p_msg = '';
    
    return PLUGINS_PLUGINMANAGER_OK;
}

function plugins_pluginmanager_uninstall_plugin( &$p_msg, $p_step ) {
    $p_msg = '';

    if ( $p_step == 1 ) {
        if ( !pm_file_move( 'plugins_page.php', 'plugins' . DIRECTORY_SEPARATOR . 'pluginmanager' . DIRECTORY_SEPARATOR . 'plugins_page.php' ) ) {
            return PLUGINS_PLUGINMANAGER_FAIL;
        }
        if ( !pm_file_move( 'plugins_install_page.php', 'plugins' . DIRECTORY_SEPARATOR . 'pluginmanager' . DIRECTORY_SEPARATOR . 'plugins_install_page.php' ) ) {
            return PLUGINS_PLUGINMANAGER_FAIL;
        }
        if ( !pm_file_move( 'plugins_uninstall_page.php', 'plugins' . DIRECTORY_SEPARATOR . 'pluginmanager' . DIRECTORY_SEPARATOR . 'plugins_uninstall_page.php' ) ) {
            return PLUGINS_PLUGINMANAGER_FAIL;
        }
        if ( !pm_file_move( 'plugins_package_page.php', 'plugins' . DIRECTORY_SEPARATOR . 'pluginmanager' . DIRECTORY_SEPARATOR . 'plugins_package_page.php' ) ) {
            return PLUGINS_PLUGINMANAGER_FAIL;
        }
        if ( !pm_file_move( 'plugins_upgrade_page.php', 'plugins' . DIRECTORY_SEPARATOR . 'pluginmanager' . DIRECTORY_SEPARATOR . 'plugins_upgrade_page.php' ) ) {
            return PLUGINS_PLUGINMANAGER_FAIL;
        }
    } else if ( $p_step == 2 ) {
        $t_main_menu_custom_options = config_get( 'main_menu_custom_options', array() );
        for( $i=0; $i<count( $t_main_menu_custom_options ); $i++ ) {
            if ( $t_main_menu_custom_options[$i] == array( 'plugins_pluginmanager_link', ADMINISTRATOR, 'plugins_page.php' ) ) {
                unset( $t_main_menu_custom_options[$i] );
            }
        }
        config_set( 'main_menu_custom_options', $t_main_menu_custom_options );
    } else {
        if ( db_is_connected() ) {
            $t_query = 'DROP TABLE ' . config_get( 'db_table_prefix' ) . '_plugins_pm_list_table';
            if ( !db_query( $t_query ) ) {
                return PLUGINS_PLUGINMANAGER_FAIL;
            }
            $t_query = 'DROP TABLE ' . config_get( 'db_table_prefix' ) . '_plugins_pm_dependencies_table';
            if ( !db_query( $t_query ) ) {
                return PLUGINS_PLUGINMANAGER_FAIL;
            }
        } else {
            $p_msg = 'Database not connected';
            return PLUGINS_PLUGINMANAGER_FAIL;
        }
    }
    return PLUGINS_PLUGINMANAGER_OK;
}

?>
