<?php

/**
 * Graph plugin
 *
 *
 * Created: 2007-02-20
 * Last update: 2007-05-27
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

if ( !ereg( 'plugins_install_page.php', $_SERVER['PHP_SELF'] ) && !ereg( 'plugins_uninstall_page.php', $_SERVER['PHP_SELF'] ) ) {
    header( 'Location: ../../plugins_page.php' );
    exit();
}

$t_plugins_plugin_manager_step_count = array();
$t_plugins_plugin_manager_step_count['install'] = 2;
$t_plugins_plugin_manager_step_count['upgrade'] = 2;
$t_plugins_plugin_manager_step_count['uninstall'] = 1;

function plugins_graph_install_description_plugin( $p_step ) {
    if ( $p_step == 1 ) {
        return 'SQL upgrade';
    } else {
        return 'Patch the plugin';
    }
}

function plugins_graph_upgrade_description_plugin( $p_step ) {
    if ( $p_step == 1 ) {
        return 'SQL upgrade';
    } else {
        return 'Patch the plugin';
    }
}

function plugins_graph_uninstall_description_plugin( $p_step ) {
    if ( $p_step == 1 ) {
        return 'SQL upgrade';
    }
    return '';
}

function plugins_graph_install_plugin( &$p_msg, $p_step ) {
    $p_msg = '';

    if ( $p_step == 1 ) {
        if ( db_is_connected() ) {
            $t_query = 'CREATE TABLE IF NOT EXISTS ' . config_get( 'db_table_prefix' ) . '_plugins_graph_table ( id int(7) unsigned not null auto_increment, name varchar(100) not null, title varchar(250) default \'\', type int(1) unsigned, xaxis varchar(100) not null, yaxis varchar(100) not null, primary key( id ) )';
            if ( !db_query( $t_query ) ) {
                return PLUGINS_PLUGINMANAGER_FAIL;
            }
        } else {
            $p_msg = 'Database not connected';
            return PLUGINS_PLUGINMANAGER_FAIL;
        }
    } else if ( $p_step == 2 ) {
        if ( !pm_file_copy( 'plugins' . DIRECTORY_SEPARATOR . 'pluginmanager' . DIRECTORY_SEPARATOR . 'patch' . DIRECTORY_SEPARATOR . 'info_graph.php', 'plugins' . DIRECTORY_SEPARATOR . 'graph' . DIRECTORY_SEPARATOR . 'info.php' ) ) {
            $p_msg = 'Failed to copy the patch';
            return PLUGINS_PLUGINMANAGER_WARNING;
        }
    }
    return PLUGINS_PLUGINMANAGER_OK;
}

function plugins_graph_upgrade_plugin( &$p_msg, $p_step ) {
    return plugins_graph_install_plugin( &$p_msg, $p_step );
}

function plugins_graph_install_undo_plugin( &$p_msg, $p_step ) {
    $p_msg = '';
    
    return PLUGINS_PLUGINMANAGER_OK;
}

function plugins_graph_upgrade_undo_plugin( &$p_msg, $p_step ) {
    $p_msg = '';
    
    return PLUGINS_PLUGINMANAGER_OK;
}

function plugins_graph_uninstall_undo_plugin( &$p_msg, $p_step ) {
    $p_msg = '';
    
    return PLUGINS_PLUGINMANAGER_OK;
}

function plugins_graph_uninstall_plugin( &$p_msg, $p_step ) {
    $p_msg = '';

    if ( $p_step == 1 ) {
        if ( db_is_connected() ) {
            $t_query = 'DROP TABLE ' . config_get( 'db_table_prefix' ) . '_plugins_graph_table';
            if ( !db_query( $t_query ) ) {
                return PLUGINS_PLUGINMANAGER_FAIL;
            }
        } else {
            $p_msg = 'Database not connected';
            return PLUGINS_PLUGINMANAGER_FAIL;
        }
    }
    return PLUGINS_PLUGINMANAGER_OK;
}

?>
